diff --git a/gcc/diagnostics/context.h b/gcc/diagnostics/context.h
index 78663cdf1e56..c985d51f4706 100644
--- a/gcc/diagnostics/context.h
+++ b/gcc/diagnostics/context.h
@@ -46,7 +46,7 @@ using start_span_fn = void (*) (const location_print_policy &,
 
 typedef void (*text_finalizer_fn) (text_sink &,
 				   const diagnostic_info *,
-				   diagnostic_t);
+				   enum kind);
 
 /* Abstract base class for the diagnostic subsystem to make queries
    about command-line options.  */
@@ -67,8 +67,8 @@ public:
      May return NULL if no name is to be printed.
      May be passed 0 as well as the index of a particular option.  */
   virtual char *make_option_name (option_id opt_id,
-				  diagnostic_t orig_diag_kind,
-				  diagnostic_t diag_kind) const = 0;
+				  enum kind orig_diag_kind,
+				  enum kind diag_kind) const = 0;
 
   /* Return malloced memory for a URL describing the option that controls
      a diagnostic.
@@ -205,13 +205,13 @@ public:
   void
   print (pretty_printer &pp,
 	 const rich_location &richloc,
-	 diagnostic_t diagnostic_kind,
+	 enum kind diagnostic_kind,
 	 source_effect_info *effect_info) const;
 
   void
   print_as_html (xml::printer &xp,
 		 const rich_location &richloc,
-		 diagnostic_t diagnostic_kind,
+		 enum kind diagnostic_kind,
 		 source_effect_info *effect_info,
 		 html_label_writer *label_writer) const;
 
@@ -269,12 +269,15 @@ struct counters
   void dump (FILE *out, int indent) const;
   void DEBUG_FUNCTION dump () const { dump (stderr, 0); }
 
-  int get_count (diagnostic_t kind) const { return m_count_for_kind[kind]; }
+  int get_count (enum kind kind) const
+  {
+    return m_count_for_kind[static_cast<size_t> (kind)];
+  }
 
   void move_to (counters &dest);
   void clear ();
 
-  int m_count_for_kind[DK_LAST_DIAGNOSTIC_KIND];
+  int m_count_for_kind[static_cast<size_t> (kind::last_diagnostic_kind)];
 };
 
 /* This class encapsulates the state of the diagnostics subsystem
@@ -370,13 +373,13 @@ public:
     return m_option_classifier.option_unspecified_p (opt_id);
   }
 
-  bool emit_diagnostic_with_group (diagnostic_t kind,
+  bool emit_diagnostic_with_group (enum kind kind,
 				   rich_location &richloc,
 				   const metadata *metadata,
 				   option_id opt_id,
 				   const char *gmsgid, ...)
     ATTRIBUTE_GCC_DIAG(6,7);
-  bool emit_diagnostic_with_group_va (diagnostic_t kind,
+  bool emit_diagnostic_with_group_va (enum kind kind,
 				      rich_location &richloc,
 				      const metadata *metadata,
 				      option_id opt_id,
@@ -391,9 +394,9 @@ public:
   void
   report_global_digraph (const digraphs::lazy_digraph &);
 
-  diagnostic_t
+  enum kind
   classify_diagnostic (option_id opt_id,
-		       diagnostic_t new_kind,
+		       enum kind new_kind,
 		       location_t where)
   {
     return m_option_classifier.classify_diagnostic (this,
@@ -413,12 +416,12 @@ public:
 
   void maybe_show_locus (const rich_location &richloc,
 			 const source_printing_options &opts,
-			 diagnostic_t diagnostic_kind,
+			 enum kind diagnostic_kind,
 			 pretty_printer &pp,
 			 source_effect_info *effect_info);
   void maybe_show_locus_as_html (const rich_location &richloc,
 				 const source_printing_options &opts,
-				 diagnostic_t diagnostic_kind,
+				 enum kind diagnostic_kind,
 				 xml::printer &xp,
 				 source_effect_info *effect_info,
 				 html_label_writer *label_writer);
@@ -498,11 +501,11 @@ public:
 
   text_art::theme *get_diagram_theme () const { return m_diagrams.m_theme; }
 
-  int &diagnostic_count (diagnostic_t kind)
+  int &diagnostic_count (enum kind kind)
   {
-    return m_diagnostic_counters.m_count_for_kind[kind];
+    return m_diagnostic_counters.m_count_for_kind[static_cast<size_t> (kind)];
   }
-  int diagnostic_count (diagnostic_t kind) const
+  int diagnostic_count (enum kind kind) const
   {
     return m_diagnostic_counters.get_count (kind);
   }
@@ -516,8 +519,8 @@ public:
   }
 
   inline char *make_option_name (option_id opt_id,
-				 diagnostic_t orig_diag_kind,
-				 diagnostic_t diag_kind) const
+				 enum kind orig_diag_kind,
+				 enum kind diag_kind) const
   {
     if (!m_option_mgr)
       return nullptr;
@@ -544,11 +547,11 @@ public:
 
   bool diagnostic_impl (rich_location *, const metadata *,
 			option_id, const char *,
-			va_list *, diagnostic_t) ATTRIBUTE_GCC_DIAG(5,0);
+			va_list *, enum kind) ATTRIBUTE_GCC_DIAG(5,0);
   bool diagnostic_n_impl (rich_location *, const metadata *,
 			  option_id, unsigned HOST_WIDE_INT,
 			  const char *, const char *, va_list *,
-			  diagnostic_t) ATTRIBUTE_GCC_DIAG(7,0);
+			  enum kind) ATTRIBUTE_GCC_DIAG(7,0);
 
   int get_diagnostic_nesting_level () const
   {
@@ -595,7 +598,7 @@ public:
 
   bool supports_fnotice_on_stderr_p () const;
 
-  /* Raise SIGABRT on any diagnostic of severity DK_ERROR or higher.  */
+  /* Raise SIGABRT on any diagnostic of severity kind::error or higher.  */
   void
   set_abort_on_error (bool val)
   {
@@ -649,7 +652,7 @@ private:
   void get_any_inlining_info (diagnostic_info *diagnostic);
 
   void check_max_errors (bool flush);
-  void action_after_output (diagnostic_t diag_kind);
+  void action_after_output (enum kind diag_kind);
 
   /* Data members.
      Ideally, all of these would be private.  */
diff --git a/gcc/diagnostics/diagnostic-info.h b/gcc/diagnostics/diagnostic-info.h
index 621f95a856a6..052fef52f1eb 100644
--- a/gcc/diagnostics/diagnostic-info.h
+++ b/gcc/diagnostics/diagnostic-info.h
@@ -26,7 +26,7 @@ class metadata;
 
 /* A diagnostic is described by the MESSAGE to send, the FILE and LINE of
    its context and its KIND (ice, error, warning, note, ...)  See complete
-   list in diagnostic.def.  */
+   list in diagnostics/kinds.def.  */
 
 struct diagnostic_info
 {
@@ -53,7 +53,7 @@ struct diagnostic_info
   /* Auxiliary data for client.  */
   void *m_x_data;
   /* The kind of diagnostic it is about.  */
-  diagnostic_t m_kind;
+  kind m_kind;
   /* Which OPT_* directly controls this diagnostic.  */
   option_id m_option_id;
 
diff --git a/gcc/diagnostics/html-sink.cc b/gcc/diagnostics/html-sink.cc
index f62a3ca4cf44..a0202546a59f 100644
--- a/gcc/diagnostics/html-sink.cc
+++ b/gcc/diagnostics/html-sink.cc
@@ -120,7 +120,7 @@ public:
   set_main_input_filename (const char *name);
 
   void on_report_diagnostic (const diagnostic_info &diagnostic,
-			     diagnostic_t orig_diag_kind,
+			     enum kind orig_diag_kind,
 			     html_sink_buffer *buffer);
   void emit_diagram (const diagram &d);
   void emit_global_graph (const digraphs::lazy_digraph &);
@@ -161,7 +161,7 @@ private:
 
   std::unique_ptr<xml::element>
   make_element_for_diagnostic (const diagnostic_info &diagnostic,
-			       diagnostic_t orig_diag_kind,
+			       enum kind orig_diag_kind,
 			       bool alert);
 
   std::unique_ptr<xml::element>
@@ -496,10 +496,10 @@ html_builder::add_stylesheet (std::string url)
 
 void
 html_builder::on_report_diagnostic (const diagnostic_info &diagnostic,
-				    diagnostic_t orig_diag_kind,
+				    enum kind orig_diag_kind,
 				    html_sink_buffer *buffer)
 {
-  if (diagnostic.m_kind == DK_ICE || diagnostic.m_kind == DK_ICE_NOBT)
+  if (diagnostic.m_kind == kind::ice || diagnostic.m_kind == kind::ice_nobt)
     {
       /* Print a header for the remaining output to stderr, and
 	 return, attempting to print the usual ICE messages to
@@ -722,23 +722,23 @@ private:
 
 /* See https://pf3.patternfly.org/v3/pattern-library/widgets/#alerts */
 static const char *
-get_pf_class_for_alert_div (diagnostic_t diag_kind)
+get_pf_class_for_alert_div (enum kind diag_kind)
 {
   switch (diag_kind)
     {
-    case DK_DEBUG:
-    case DK_NOTE:
+    case kind::debug:
+    case kind::note:
       return "alert alert-info";
 
-    case DK_ANACHRONISM:
-    case DK_WARNING:
+    case kind::anachronism:
+    case kind::warning:
       return "alert alert-warning";
 
-    case DK_ERROR:
-    case DK_SORRY:
-    case DK_ICE:
-    case DK_ICE_NOBT:
-    case DK_FATAL:
+    case kind::error:
+    case kind::sorry:
+    case kind::ice:
+    case kind::ice_nobt:
+    case kind::fatal:
       return "alert alert-danger";
 
     default:
@@ -747,23 +747,23 @@ get_pf_class_for_alert_div (diagnostic_t diag_kind)
 }
 
 static const char *
-get_pf_class_for_alert_icon (diagnostic_t diag_kind)
+get_pf_class_for_alert_icon (enum kind diag_kind)
 {
   switch (diag_kind)
     {
-    case DK_DEBUG:
-    case DK_NOTE:
+    case kind::debug:
+    case kind::note:
       return "pficon pficon-info";
 
-    case DK_ANACHRONISM:
-    case DK_WARNING:
+    case kind::anachronism:
+    case kind::warning:
       return "pficon pficon-warning-triangle-o";
 
-    case DK_ERROR:
-    case DK_SORRY:
-    case DK_ICE:
-    case DK_ICE_NOBT:
-    case DK_FATAL:
+    case kind::error:
+    case kind::sorry:
+    case kind::ice:
+    case kind::ice_nobt:
+    case kind::fatal:
       return "pficon pficon-error-circle-o";
 
     default:
@@ -946,7 +946,7 @@ private:
 
 std::unique_ptr<xml::element>
 html_builder::make_element_for_diagnostic (const diagnostic_info &diagnostic,
-					   diagnostic_t orig_diag_kind,
+					   enum kind orig_diag_kind,
 					   bool alert)
 {
   const int diag_idx = m_next_diag_id++;
@@ -1004,7 +1004,7 @@ html_builder::make_element_for_diagnostic (const diagnostic_info &diagnostic,
   if (show_severity)
   {
     xp.push_tag ("strong");
-    xp.add_text (_(get_diagnostic_kind_text (diagnostic.m_kind)));
+    xp.add_text (_(get_text_for_kind (diagnostic.m_kind)));
     xp.pop_tag ("strong");
     xp.add_text (" ");
   }
@@ -1360,7 +1360,7 @@ public:
   }
   void
   on_report_diagnostic (const diagnostic_info &diagnostic,
-			diagnostic_t orig_diag_kind) final override
+			enum kind orig_diag_kind) final override
   {
     m_builder.on_report_diagnostic (diagnostic, orig_diag_kind, m_buffer);
   }
@@ -1463,7 +1463,7 @@ open_html_output_file (context &dc,
     {
       rich_location richloc (line_maps, UNKNOWN_LOCATION);
       dc.emit_diagnostic_with_group
-	(DK_ERROR, richloc, nullptr, 0,
+	(kind::error, richloc, nullptr, 0,
 	 "unable to determine filename for HTML output");
       return output_file ();
     }
@@ -1476,7 +1476,7 @@ open_html_output_file (context &dc,
     {
       rich_location richloc (line_maps, UNKNOWN_LOCATION);
       dc.emit_diagnostic_with_group
-	(DK_ERROR, richloc, nullptr, 0,
+	(kind::error, richloc, nullptr, 0,
 	 "unable to open %qs for HTML output: %m",
 	 filename.get ());
       return output_file ();
@@ -1620,7 +1620,7 @@ test_simple_log ()
   test_html_context dc;
 
   rich_location richloc (line_table, UNKNOWN_LOCATION);
-  dc.report (DK_ERROR, richloc, nullptr, 0, "this is a test: %qs", "foo");
+  dc.report (kind::error, richloc, nullptr, 0, "this is a test: %qs", "foo");
 
   const xml::document &doc  = dc.get_document ();
 
diff --git a/gcc/diagnostic.def b/gcc/diagnostics/kinds.def
similarity index 53%
rename from gcc/diagnostic.def
rename to gcc/diagnostics/kinds.def
index ab2185c2cd07..2a0a0a6c7095 100644
--- a/gcc/diagnostic.def
+++ b/gcc/diagnostics/kinds.def
@@ -16,40 +16,40 @@ You should have received a copy of the GNU General Public License
 along with GCC; see the file COPYING3.  If not see
 <http://www.gnu.org/licenses/>.  */
 
-/* DK_UNSPECIFIED must be first so it has a value of zero.  We never
+/* kind::unspecified must be first so it has a value of zero.  We never
    assign this kind to an actual diagnostic, we only use this in
    variables that can hold a kind, to mean they have yet to have a
    kind specified.  I.e. they're uninitialized.  Within the diagnostic
    machinery, this kind also means "don't change the existing kind",
    meaning "no change is specified".  */
-DEFINE_DIAGNOSTIC_KIND (DK_UNSPECIFIED, "", NULL)
+DEFINE_DIAGNOSTIC_KIND (unspecified, "", NULL)
 
-/* If a diagnostic is set to DK_IGNORED, it won't get reported at all.
+/* If a diagnostic is set to kind::ignored, it won't get reported at all.
    This is used by the diagnostic machinery when it wants to disable a
    diagnostic without disabling the option which causes it.  */
-DEFINE_DIAGNOSTIC_KIND (DK_IGNORED, "", NULL)
+DEFINE_DIAGNOSTIC_KIND (ignored, "", NULL)
 
 /* The remainder are real diagnostic types.  */
-DEFINE_DIAGNOSTIC_KIND (DK_FATAL, "fatal error: ", "error")
-DEFINE_DIAGNOSTIC_KIND (DK_ICE, "internal compiler error: ", "error")
-DEFINE_DIAGNOSTIC_KIND (DK_ERROR, "error: ", "error")
-DEFINE_DIAGNOSTIC_KIND (DK_SORRY, "sorry, unimplemented: ", "error")
-DEFINE_DIAGNOSTIC_KIND (DK_WARNING, "warning: ", "warning")
-DEFINE_DIAGNOSTIC_KIND (DK_ANACHRONISM, "anachronism: ", "warning")
-DEFINE_DIAGNOSTIC_KIND (DK_NOTE, "note: ", "note")
-DEFINE_DIAGNOSTIC_KIND (DK_DEBUG, "debug: ", "note")
+DEFINE_DIAGNOSTIC_KIND (fatal, "fatal error: ", "error")
+DEFINE_DIAGNOSTIC_KIND (ice, "internal compiler error: ", "error")
+DEFINE_DIAGNOSTIC_KIND (error, "error: ", "error")
+DEFINE_DIAGNOSTIC_KIND (sorry, "sorry, unimplemented: ", "error")
+DEFINE_DIAGNOSTIC_KIND (warning, "warning: ", "warning")
+DEFINE_DIAGNOSTIC_KIND (anachronism, "anachronism: ", "warning")
+DEFINE_DIAGNOSTIC_KIND (note, "note: ", "note")
+DEFINE_DIAGNOSTIC_KIND (debug, "debug: ", "note")
 
 /* For use when using the diagnostic_show_locus machinery to show
    a range of events within a path.  */
-DEFINE_DIAGNOSTIC_KIND (DK_DIAGNOSTIC_PATH, "path: ", "path")
+DEFINE_DIAGNOSTIC_KIND (path, "path: ", "path")
 
-/* These two would be re-classified as DK_WARNING or DK_ERROR, so the
+/* These two would be re-classified as kind::warning or kind::error, so the
 prefix does not matter.  */
-DEFINE_DIAGNOSTIC_KIND (DK_PEDWARN, "pedwarn: ", NULL)
-DEFINE_DIAGNOSTIC_KIND (DK_PERMERROR, "permerror: ", NULL)
-/* This one is just for counting DK_WARNING promoted to DK_ERROR
+DEFINE_DIAGNOSTIC_KIND (pedwarn, "pedwarn: ", NULL)
+DEFINE_DIAGNOSTIC_KIND (permerror, "permerror: ", NULL)
+/* This one is just for counting kind::warning promoted to kind::error
    due to -Werror and -Werror=warning.  */
-DEFINE_DIAGNOSTIC_KIND (DK_WERROR, "error: ", NULL)
-/* This is like DK_ICE, but backtrace is not printed.  Used in the driver
+DEFINE_DIAGNOSTIC_KIND (werror, "error: ", NULL)
+/* This is like kind::ICE, but backtrace is not printed.  Used in the driver
    when reporting fatal signal in the compiler.  */
-DEFINE_DIAGNOSTIC_KIND (DK_ICE_NOBT, "internal compiler error: ", "error")
+DEFINE_DIAGNOSTIC_KIND (ice_nobt, "internal compiler error: ", "error")
diff --git a/gcc/diagnostics/kinds.h b/gcc/diagnostics/kinds.h
new file mode 100644
index 000000000000..7b4a1687d0e2
--- /dev/null
+++ b/gcc/diagnostics/kinds.h
@@ -0,0 +1,45 @@
+/* An enum used to discriminate severities of diagnostics.
+   Copyright (C) 1998-2025 Free Software Foundation, Inc.
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify it under
+the terms of the GNU General Public License as published by the Free
+Software Foundation; either version 3, or (at your option) any later
+version.
+
+GCC is distributed in the hope that it will be useful, but WITHOUT ANY
+WARRANTY; without even the implied warranty of MERCHANTABILITY or
+FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+for more details.
+
+You should have received a copy of the GNU General Public License
+along with GCC; see the file COPYING3.  If not see
+<http://www.gnu.org/licenses/>.  */
+
+#ifndef GCC_DIAGNOSTICS_KINDS_H
+#define GCC_DIAGNOSTICS_KINDS_H
+
+namespace diagnostics {
+
+/* Constants used to discriminate diagnostics.  */
+enum class kind
+{
+#define DEFINE_DIAGNOSTIC_KIND(K, msgid, C) K,
+#include "diagnostics/kinds.def"
+#undef DEFINE_DIAGNOSTIC_KIND
+  last_diagnostic_kind,
+  /* This is used for tagging pragma pops in the diagnostic
+     classification history chain.  */
+  pop,
+  /* This is used internally to note that a diagnostic is enabled
+     without mandating any specific type.  */
+  any
+};
+
+extern const char *get_text_for_kind (enum diagnostics::kind);
+extern const char *get_color_for_kind (enum diagnostics::kind);
+
+} // namespace diagnostics
+
+#endif /* ! GCC_DIAGNOSTICS_KINDS_H */
diff --git a/gcc/diagnostics/lazy-paths.cc b/gcc/diagnostics/lazy-paths.cc
index 216ad744a3b7..4934651c3229 100644
--- a/gcc/diagnostics/lazy-paths.cc
+++ b/gcc/diagnostics/lazy-paths.cc
@@ -139,8 +139,8 @@ public:
     return 0;
   }
   char *make_option_name (diagnostics::option_id,
-			  diagnostic_t,
-			  diagnostic_t) const final override
+			  enum kind,
+			  enum kind) const final override
   {
     return nullptr;
   }
@@ -175,7 +175,7 @@ test_emission (pretty_printer *event_pp)
 
     diagnostics::option_id opt_id (42); // has to be non-zero
     bool emitted
-      = dc.emit_diagnostic_with_group (DK_WARNING, rich_loc, nullptr,
+      = dc.emit_diagnostic_with_group (kind::warning, rich_loc, nullptr,
 				       opt_id,
 				       "this warning should be skipped");
     ASSERT_FALSE (emitted);
@@ -191,7 +191,7 @@ test_emission (pretty_printer *event_pp)
     ASSERT_FALSE (rich_loc.m_path.generated_p ());
 
     bool emitted
-      = dc.emit_diagnostic_with_group (DK_ERROR, rich_loc, nullptr, 0,
+      = dc.emit_diagnostic_with_group (kind::error, rich_loc, nullptr, 0,
 				       "this is a test");
     ASSERT_TRUE (emitted);
     ASSERT_TRUE (rich_loc.m_path.generated_p ());
diff --git a/gcc/diagnostics/option-classifier.cc b/gcc/diagnostics/option-classifier.cc
index d3f0985d4647..98316b46f1fe 100644
--- a/gcc/diagnostics/option-classifier.cc
+++ b/gcc/diagnostics/option-classifier.cc
@@ -30,9 +30,9 @@ void
 option_classifier::init (int n_opts)
 {
   m_n_opts = n_opts;
-  m_classify_diagnostic = XNEWVEC (diagnostic_t, n_opts);
+  m_classify_diagnostic = XNEWVEC (enum kind, n_opts);
   for (int i = 0; i < n_opts; i++)
-    m_classify_diagnostic[i] = DK_UNSPECIFIED;
+    m_classify_diagnostic[i] = kind::unspecified;
   m_push_list = vNULL;
   m_classification_history = vNULL;
 }
@@ -111,27 +111,27 @@ option_classifier::pop (location_t where)
   else
     jump_to = 0;
 
-  classification_change_t v = { where, jump_to, DK_POP };
+  classification_change_t v = { where, jump_to, kind::pop };
   m_classification_history.safe_push (v);
 }
 
 /* Interface to specify diagnostic kind overrides.  Returns the
-   previous setting, or DK_UNSPECIFIED if the parameters are out of
+   previous setting, or kind::unspecified if the parameters are out of
    range.  If OPTION_ID is zero, the new setting is for all the
    diagnostics.  */
 
-diagnostic_t
+enum kind
 option_classifier::classify_diagnostic (const context *dc,
 					option_id opt_id,
-					diagnostic_t new_kind,
+					enum kind new_kind,
 					location_t where)
 {
-  diagnostic_t old_kind;
+  enum kind old_kind;
 
   if (opt_id.m_idx < 0
       || opt_id.m_idx >= m_n_opts
-      || new_kind >= DK_LAST_DIAGNOSTIC_KIND)
-    return DK_UNSPECIFIED;
+      || new_kind >= kind::last_diagnostic_kind)
+    return kind::unspecified;
 
   old_kind = m_classify_diagnostic[opt_id.m_idx];
 
@@ -141,11 +141,11 @@ option_classifier::classify_diagnostic (const context *dc,
     {
       unsigned i;
 
-      /* Record the command-line status, so we can reset it back on DK_POP. */
-      if (old_kind == DK_UNSPECIFIED)
+      /* Record the command-line status, so we can reset it back on kind::pop. */
+      if (old_kind == kind::unspecified)
 	{
 	  old_kind = (!dc->option_enabled_p (opt_id)
-		      ? DK_IGNORED : DK_ANY);
+		      ? kind::ignored : kind::any);
 	  m_classify_diagnostic[opt_id.m_idx] = old_kind;
 	}
 
@@ -172,15 +172,15 @@ option_classifier::classify_diagnostic (const context *dc,
      #pragma GCC diagnostic
    directives recorded within this object.
 
-   Return the new kind of DIAGNOSTIC if it was updated, or DK_UNSPECIFIED
+   Return the new kind of DIAGNOSTIC if it was updated, or kind::unspecified
    otherwise.  */
 
-diagnostic_t
+enum kind
 option_classifier::
 update_effective_level_from_pragmas (diagnostic_info *diagnostic) const
 {
   if (m_classification_history.is_empty ())
-    return DK_UNSPECIFIED;
+    return kind::unspecified;
 
   /* Iterate over the locations, checking the diagnostic disposition
      for the diagnostic at each.  If it's explicitly set as opposed
@@ -197,7 +197,7 @@ update_effective_level_from_pragmas (diagnostic_info *diagnostic) const
 	  if (!linemap_location_before_p (line_table, pragloc, loc))
 	    continue;
 
-	  if (p->kind == (int) DK_POP)
+	  if (p->kind == kind::pop)
 	    {
 	      /* Move on to the next region.  */
 	      i = p->option;
@@ -208,15 +208,15 @@ update_effective_level_from_pragmas (diagnostic_info *diagnostic) const
 	  /* The option 0 is for all the diagnostics.  */
 	  if (opt_id == 0 || opt_id == diagnostic->m_option_id)
 	    {
-	      diagnostic_t kind = p->kind;
-	      if (kind != DK_UNSPECIFIED)
+	      enum kind kind = p->kind;
+	      if (kind != kind::unspecified)
 		diagnostic->m_kind = kind;
 	      return kind;
 	    }
 	}
     }
 
-  return DK_UNSPECIFIED;
+  return kind::unspecified;
 }
 
 } // namespace diagnostics
diff --git a/gcc/diagnostics/option-classifier.h b/gcc/diagnostics/option-classifier.h
index 6ed417fe70a8..bf089b6f6c30 100644
--- a/gcc/diagnostics/option-classifier.h
+++ b/gcc/diagnostics/option-classifier.h
@@ -44,22 +44,22 @@ public:
 
   bool option_unspecified_p (option_id opt_id) const
   {
-    return get_current_override (opt_id) == DK_UNSPECIFIED;
+    return get_current_override (opt_id) == kind::unspecified;
   }
 
-  diagnostic_t get_current_override (option_id opt_id) const
+  enum kind get_current_override (option_id opt_id) const
   {
     gcc_assert (opt_id.m_idx < m_n_opts);
     return m_classify_diagnostic[opt_id.m_idx];
   }
 
-  diagnostic_t
+  enum kind
   classify_diagnostic (const context *context,
 		       option_id opt_id,
-		       diagnostic_t new_kind,
+		       enum kind new_kind,
 		       location_t where);
 
-  diagnostic_t
+  enum kind
   update_effective_level_from_pragmas (diagnostic_info *diagnostic) const;
 
   int pch_save (FILE *);
@@ -73,12 +73,12 @@ private:
   {
     location_t location;
 
-    /* For DK_POP, this is the index of the corresponding push (as stored
+    /* For kind::pop, this is the index of the corresponding push (as stored
        in m_push_list).
        Otherwise, this is an option index.  */
     int option;
 
-    diagnostic_t kind;
+    enum kind kind;
   };
 
   int m_n_opts;
@@ -86,10 +86,10 @@ private:
   /* For each option index that can be passed to warning() et al
      (OPT_* from options.h when using this code with the core GCC
      options), this array may contain a new kind that the diagnostic
-     should be changed to before reporting, or DK_UNSPECIFIED to leave
-     it as the reported kind, or DK_IGNORED to not report it at
+     should be changed to before reporting, or kind::unspecified to leave
+     it as the reported kind, or kind::ignored to not report it at
      all.  */
-  diagnostic_t *m_classify_diagnostic;
+  enum kind *m_classify_diagnostic;
 
   /* History of all changes to the classifications above.  This list
      is stored in location-order, so we can search it, either
diff --git a/gcc/diagnostics/output-spec.h b/gcc/diagnostics/output-spec.h
index dd9541f99e47..059346a25d20 100644
--- a/gcc/diagnostics/output-spec.h
+++ b/gcc/diagnostics/output-spec.h
@@ -103,7 +103,7 @@ public:
   {
     m_dc.begin_group ();
     rich_location richloc (m_control_location_mgr, m_loc);
-    m_dc.diagnostic_impl (&richloc, nullptr, -1, gmsgid, ap, DK_ERROR);
+    m_dc.diagnostic_impl (&richloc, nullptr, -1, gmsgid, ap, kind::error);
     m_dc.end_group ();
   }
 
diff --git a/gcc/diagnostics/paths-output.cc b/gcc/diagnostics/paths-output.cc
index 0349f3d943d6..c132d6735042 100644
--- a/gcc/diagnostics/paths-output.cc
+++ b/gcc/diagnostics/paths-output.cc
@@ -638,7 +638,7 @@ struct event_range
 
     /* Call diagnostic_show_locus to show the events using labels.  */
     diagnostic_show_locus (&dc, text_output.get_source_printing_options (),
-			   &m_richloc, DK_DIAGNOSTIC_PATH, &pp,
+			   &m_richloc, diagnostics::kind::path, &pp,
 			   effect_info);
 
     /* If we have a macro expansion, show the expansion to the user.  */
@@ -702,7 +702,7 @@ struct event_range
     /* Call diagnostic_show_locus_as_html to show the source,
        showing events using labels.  */
     diagnostic_show_locus_as_html (&dc, dc.m_source_printing,
-				   &m_richloc, DK_DIAGNOSTIC_PATH, xp,
+				   &m_richloc, diagnostics::kind::path, xp,
 				   effect_info, event_label_writer);
 
     // TODO: show macro expansions
